package com.learning.service;

import com.learning.service.model.User;
import java.util.List;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.Spy;
import org.mockito.junit.jupiter.MockitoExtension;

/*
@Spy annotation is used to spy on existing resource. It helps to partially mock an object.
 */
@ExtendWith(MockitoExtension.class)
public class UserSrvTest {

  @Spy
  private UserSrv objUndrTest;

  @Test
  public void getUsersShouldReturnEmployeeListIfFetchIsTrue() {
    final List<User> response = objUndrTest.getUsers(true);
    Assertions.assertNotNull(response);
    Assertions.assertEquals(response.size(), 10);
  }

  @Test
  public void getUsersShouldReturnEmptyEmployeeListIfFetchIsFalse() {
    Assertions.assertEquals(objUndrTest.getUsers(false).size(), 0);
  }
}